do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt) end,
    keypressed = function(self, key)
      self.key = key
      if self.active then
        if self.key == "x" then
          if self.text_index ~= #self.text then
            self.text_index = self.text_index + 1
          else
            return self:stop()
          end
        end
      end
    end,
    add = function(self, txt, added_face)
      self.txt, self.added_face = txt, added_face
      self.text[#self.text + 1] = self.txt
      if self.added_face then
        self.faces[#self.faces + 1] = self.added_face
      else
        self.faces[#self.faces + 1] = -1
      end
    end,
    stop = function(self)
      self.cb = mad.object:findUnique("convo_box")
      mad.object:remove(self.cb)
      for k in pairs((self.text)) do
        self.text[k] = nil
      end
      for k in pairs((self.faces)) do
        self.faces[k] = nil
      end
      self.text_index = 1
      self.player = mad.object:findUnique("player")
      self.player.talking = false
      self.active = false
    end,
    start = function(self)
      mad.object:create(ConvoBox())
      self.player = mad.object:findUnique("player")
      self.player.talking = true
      self.active = true
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.x = 0
      self.y = 0
      self.persistent = true
      self.active = false
      self.text = { }
      self.faces = { }
      self.text_index = 1
      self.face = mad.sprite:img("player_sheet.png")
      return _parent_0.__init(self, self, 0, 0, "text_manager")
    end,
    __base = _base_0,
    __name = "TextManager",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  TextManager = _class_0
end
