do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt)
      if #self.text_manager.text == 0 then
        return mad.object:remove(self)
      end
    end,
    draw = function(self)
      love.graphics.setColor(0, 0, 0, 100)
      love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
      love.graphics.setColor(255, 255, 255)
      if self.text_manager.faces[self.text_manager.text_index] and self.text_manager.faces[self.text_manager.text_index] ~= -1 then
        love.graphics.draw(self.text_manager.faces[self.text_manager.text_index], self.x, self.y - 75)
      end
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      return love.graphics.print(self.text_manager.text[self.text_manager.text_index], self.x + 32, self.y + 32)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.x = 12
      self.y = love.graphics.getHeight() - 210
      self.z = -10000
      self.text_manager = mad.object:findUnique("text_manager")
      return _parent_0.__init(self, self, love.graphics.getWidth() - 25, 200, "convo_box")
    end,
    __base = _base_0,
    __name = "ConvoBox",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ConvoBox = _class_0
end
