do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self)
      if self.shake_timer > 0 then
        self.set_cam = false
        self.x_val = math.random(-self.str, self.str)
        self.y_val = math.random(-self.str, self.str)
        camera:setPosition(self.cam_x + self.x_val, self.cam_y + self.x_val)
        self.shake_timer = self.shake_timer - 1
      else
        self.x_val = 0
        self.y_val = 0
        self.shake_timer = 0
        self.str = 0
        if not self.set_cam then
          camera:setPosition(love.graphics.getWidth() / 2, love.graphics.getHeight() / 2)
          self.set_cam = true
        end
      end
    end,
    shake = function(self, str, shake_timer)
      self.str, self.shake_timer = str, shake_timer
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      self.x = 0
      self.y = 0
      self.x_val = 0
      self.y_val = 0
      self.cam_x, self.cam_y = camera:getPosition()
      self.shake_timer = 0
      self.str = 0
      self.set_cam = false
      return _parent_0.__init(self, self, 0, 0, "screenshake")
    end,
    __base = _base_0,
    __name = "ScreenShake",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  ScreenShake = _class_0
end
