require("gunManager")
do
  local _base_0 = { }
  _base_0.__index = _base_0
  local _class_0 = setmetatable({
    __init = function() end,
    __base = _base_0,
    __name = "PlayerManager"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.max_health = 1
  self.gun_grip = gunManager.grip[1]
  self.gun_base = gunManager.base[1]
  self.gun_barrel = gunManager.barrel[1]
  self.gun_ammo = gunManager.ammoTypes[2]
  self.gun_name = self.gun_grip.num .. self.gun_barrel.num .. " " .. self.gun_base.num
  if self.gun_base.ver == "auto" then
    self.ver_multiplier = 1
  elseif self.gun_base.ver == "single" then
    self.ver_multiplier = 2
  end
  self.gun_damage = math.ceil((((self.gun_grip.dmg + self.gun_base.dmg + self.gun_barrel.dmg)) * self.ver_multiplier) - ((self.gun_grip.range * (0.1 * self.ver_multiplier) + self.gun_base.fire_rate * (0.2 * self.ver_multiplier)) * 2))
  self.gun_grip.kickback = self.gun_grip.kickback + (self.gun_damage * 0.2)
  if self.gun_damage < 1 then
    self.gun_damage = 1
  end
  print("Gun damage: ", self.gun_damage)
  self.inventory = { }
  table.insert(self.inventory, InvAmmo(999, gunManager.ammoTypes[1]))
  PlayerManager = _class_0
end
